/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred."
 *
 */
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Header: insertln.c 1.3 89/10/10 $@(#)curses:screen/insertln.c	1.3.1.1"
# include	"curses.ext"

/*
 *	This routine performs an insert-line on the _window, leaving
 * (_cury,_curx) unchanged.
 *
 */
winsertln(win)
register WINDOW	*win;
{
	register chtype	*temp;
	register int	y;

	temp = win->_y[win->_maxy-1];
	win->_firstch[win->_cury] = 0;
	win->_lastch[win->_cury] = win->_maxx - 1;
	win->_need_idl = TRUE;
	win->_flags |= _WINCHANGED;
	for (y = win->_maxy - 1; y > win->_cury; --y) {
		win->_y[y] = win->_y[y-1];
	}

	win->_y[win->_cury] = temp;
	memSset(temp, (chtype) ' ', win->_maxx);

	if (win->_cury == lines - 1 && win->_y[lines-1][COLS-1] != ' ')
		if (win->_scroll && !(win->_flags&_ISPAD)) {
			wrefresh(win);
			scroll(win);
			win->_cury--;
		}
		else
			return ERR;
	touchwin(win);
	return OK;
}
